package com.steerinfo.baseinfo.meterbasevoicerelation.controller;

import com.steerinfo.framework.controller.BaseRESTfulController;
import com.steerinfo.framework.controller.RESTfulResult;
import com.steerinfo.framework.service.pagehelper.PageList;
import com.steerinfo.framework.utils.collection.ListUtils;
import com.steerinfo.baseinfo.meterbasevoicerelation.model.MeterBaseVoiceRelation;
import com.steerinfo.baseinfo.meterbasevoicerelation.service.IMeterBaseVoiceRelationService;
import com.steerinfo.meterwork.except.MarkerMetException;
import com.steerinfo.meterwork.meterworkcaractual.model.MeterWorkCarActual;
import com.steerinfo.util.StringUtils;
import io.swagger.annotations.ApiImplicitParam;
import io.swagger.annotations.ApiImplicitParams;
import io.swagger.annotations.ApiOperation;
import org.apache.shiro.authz.annotation.RequiresPermissions;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.transaction.interceptor.TransactionAspectSupport;
import org.springframework.web.bind.annotation.*;

import java.util.Arrays;
import java.util.HashMap;
import java.util.List;
import java.util.ArrayList;
import java.math.BigDecimal;

/**
 * MeterBaseVoiceRelation RESTful接口：
 * @author generator
 * @version 1.0-SNAPSHORT 2022-01-05 05:34
 * 类描述
 * 修订历史：
 * 日期：2022-01-05
 * 作者：generator
 * 参考：
 * 描述：MeterBaseVoiceRelation RESTful接口
 * @see null
 * @Copyright 湖南视拓信息技术股份有限公司. All rights reserved.
 */
@RestController
@RequestMapping("/${api.version}/meterbasevoicerelations")
public class MeterBaseVoiceRelationController extends BaseRESTfulController {

    @Autowired
    IMeterBaseVoiceRelationService meterBaseVoiceRelationService;

    @ApiOperation(value="获取列表", notes="分页查询")
    @ApiImplicitParams({
        @ApiImplicitParam(name = "pageNum", value = "查询页数", required = false, dataType = "Integer"),
        @ApiImplicitParam(name = "pageSize", value = "每页记录数", required = false, dataType = "Integer")
    })
    //@RequiresPermissions("meterbasevoicerelation:view")
    @GetMapping(value = "/")
    public RESTfulResult list(@RequestParam HashMap parmas,Integer pageNum, Integer pageSize){
        PageList<MeterBaseVoiceRelation> list = meterBaseVoiceRelationService.queryForPage(parmas, pageNum, pageSize);
        return success(list);
    }

    @ApiOperation(value="获取列表", notes="分页模糊查询")
    @ApiImplicitParams({
        @ApiImplicitParam(name = "pageNum", value = "查询页数", required = false, dataType = "Integer"),
        @ApiImplicitParam(name = "pageSize", value = "每页记录数", required = false, dataType = "Integer")
    })
    //@RequiresPermissions("meterbasevoicerelation:view")
    @GetMapping(value = "/like/")
    public RESTfulResult listLike(@RequestParam HashMap parmas,Integer pageNum, Integer pageSize){
        PageList<MeterBaseVoiceRelation> list = meterBaseVoiceRelationService.queryLikeForPage(parmas, pageNum, pageSize);
        return success(list);
    }
    
    @ApiOperation(value="创建", notes="根据MeterBaseVoiceRelation对象创建")
    @ApiImplicitParam(name = "meterBaseVoiceRelation", value = "详细实体meterBaseVoiceRelation", required = true, dataType = "MeterBaseVoiceRelation")
    //@RequiresPermissions("meterbasevoicerelation:create")
    @PostMapping(value = "/")
    public RESTfulResult add(@ModelAttribute MeterBaseVoiceRelation model){
        try {
            String msg = meterBaseVoiceRelationService.checkandadd(model);
            if (StringUtils.isNotEmpty(msg)) {
                return failed(null, msg);
            }
        } catch (Exception e) {
            e.printStackTrace();
            TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
            return failed(null, "操作异常，请确认！");
        }

        return success();
    }

    @ApiOperation(value="获取详细信息", notes="根据url的id来获取详细信息")
    @ApiImplicitParam(paramType = "path", name = "id", value = "ID", required = true, dataType = "String")
    //@RequiresPermissions("meterbasevoicerelation:view")
    @GetMapping(value = "/{id}")
    public RESTfulResult get(@PathVariable String id){
        MeterBaseVoiceRelation meterBaseVoiceRelation = meterBaseVoiceRelationService.getById(id);
        return success(meterBaseVoiceRelation);
    }

    @ApiOperation(value="更新详细信息", notes="根据url的id来指定更新对象，并根据传过来的meterBaseVoiceRelation信息来更新详细信息")
    @ApiImplicitParams({
        @ApiImplicitParam(paramType = "path", name = "id", value = "ID", required = true, dataType = "String"),
        @ApiImplicitParam(name = "meterBaseVoiceRelation", value = "详细实体meterBaseVoiceRelation", required = true, dataType = "MeterBaseVoiceRelation")
    })
    //@RequiresPermissions("meterbasevoicerelation:update")
    @PutMapping(value = "/{id}", produces  = "application/json;charset=UTF-8")
    public RESTfulResult update(@PathVariable String id, @RequestBody MeterBaseVoiceRelation model){
        model.setId(id);
        MeterBaseVoiceRelation meterBaseVoiceRelation = meterBaseVoiceRelationService.modify(model);
        return success(meterBaseVoiceRelation);
    }

    @ApiOperation(value="删除", notes="根据url的id来指定删除对象")
    @ApiImplicitParam(paramType = "path", name = "id", value = "ID", required = true, dataType = "String")
    //@RequiresPermissions("meterbasevoicerelation:delete")
    @DeleteMapping(value = "/{id}")//String
    public RESTfulResult delete(@PathVariable String id){
    	List<String> list = Arrays.asList(id.split(","));
    	if(ListUtils.isNotEmpty(list)) {
	    	List<String> ids = ListUtils.convertList(list);
			  meterBaseVoiceRelationService.delete(ids);
    	}
      return success();
    }

    @ApiOperation(value="获取列表", notes="分页查询")
    @ApiImplicitParams({
            @ApiImplicitParam(name = "pageNum", value = "查询页数", required = false, dataType = "Integer"),
            @ApiImplicitParam(name = "pageSize", value = "每页记录数", required = false, dataType = "Integer")
    })
    //@RequiresPermissions("meterbasevoicerelation:view")
    @GetMapping(value = "/listrelation")
    public RESTfulResult listRelation(@RequestParam HashMap parmas,Integer pageNum, Integer pageSize){
        PageList list = meterBaseVoiceRelationService.queryForRelationPage(parmas, pageNum, pageSize);
        return success(list);
    }
}
